import java.util.Scanner;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;

/**
 * This class contains code for reading subject information from a file,
 * forming testing pools, and determining which subjects in those pools
 * must be positive.
 * 
 * @author Brad Richards
 * @version 1.0
 */
public class PoolProcessor
{
    private ArrayList<IntSet> pools;    // All of the subject pools
    private ArrayList<String> names;    // Names of each pool

    /**
     * The constructor takes the name of a data file. It reads the information
     * on subjects and their pool assignments from the file, and creates a list
     * of Pool objects representing the subject pools.
     * 
     * @param filename The name of a file containing information on pools.
     */
    public PoolProcessor(String filename) throws FileNotFoundException 
    {
        // Create (empty) lists of pools and names
        // Create Scanner to read from specified file
        // While there's stuff to read in the file
        //   Read pool name and subject ID
        //   Add ID to specified pool (set):
        //     If pool name is in names, find its index and add ID to corresponding pool
        //     Otherwise add name to names, create new pool & add ID, add pool to pools.
        // Print all pools (sets)
    }

    /**
     * This method is passed the names of the *pools* that tested positive, 
     * and determines which *subjects* in those pools must be positive.
     * At the end of the process, the subjects testing positive are printed.
     * 
     * @param positivePools A list containing IDs of pools testing positive
     */
    public void detect(ArrayList<String> positivePools) 
    {
        // Merge all the positive pools into one big positive pool:
        //   Create new pool to hold suspects
        //   For each name in positivePools
        //     Find corresponding set in pools
        //     Merge its contents with the pool of suspects
        // Look for evidence that could eliminate subjects from big pool:
        //   For each name in names
        //     If not in positivePools, find corresponding set in pools...
        //     ...and subtract its contents from suspects set
        // Print remaining contents of big pool
    }
}
